Camera = Core.class(Sprite)

local rasterHeight, rasterWidth, worldWidth, worldHeight, target, container, zoomLevel


function Camera:init(ww, wh, ct)

rasterWidth = application:getContentWidth()
rasterHeight = application:getContentHeight()
worldWidth = ww
worldHeight = wh
target = ct
zoomLevel = 1
container = target:getParent()


print("Camera init. Target: ".. target.name .." Raster Size: ".. rasterWidth .."x".. rasterHeight .." World size: ".. worldWidth .."x".. worldHeight)


	local wall = Shape.new()
	wall:beginPath()
	wall:setLineStyle(1, 0x000000,1)
	wall:setFillStyle(Shape.SOLID, 0x000000, 0.1)
	wall:moveTo(-rasterWidth/2,-rasterHeight/2)
	wall:lineTo(rasterWidth/2, -rasterHeight/2)
	wall:lineTo(rasterWidth/2, rasterHeight/2)
	wall:lineTo(-rasterWidth/2, rasterHeight/2)
	wall:closePath()
	wall:endPath()
	self:addChild(wall)	
	
end


function Camera:lookAt( targetX, targetY)


local offsetX, offsetY = getCurrentOffset()


container:setPosition(offsetX, offsetY)

end


function getWorldPoint(rasterX, rasterY)

-- Need to convert world points to screen points after scaling because width and height of the container changes after a scale :
-- New Width = Width  * zoom ratio




end



function getCurrentOffset()
local offsetX, offsetY = 0,0

if( (worldWidth - target:getX()) < rasterWidth/2) then
		offsetX = -worldWidth + rasterWidth
	elseif(target:getX() >= rasterWidth/2) then
		offsetX = -(target:getX() - rasterWidth/2)
	end

	if( (worldHeight - target:getY()) < rasterHeight/2) then
		offsetY = -worldHeight + rasterHeight
	elseif( target:getY() >= rasterHeight/2) then
		offsetY = -(target:getY() - rasterHeight/2)
		
	end


--print("X ".. container:getX() .."	Y ".. container:getY() .."	W ".. container:getWidth() .."	H ".. container:getHeight() )


return offsetX, offsetY

end


function Camera:getZoom()
 return zoomLevel;
end


function Camera:setZoom(zoomLevel)
	if(zoomLevel <= 0) then
	 zoomLevel =  1
	elseif(zoomLevel >= 2) then
		zoomLevel = 2
	end
	
--	local wcx, wcy = getWorldPoint(rasterWidth/2, rasterHeight/2)
--	container:setScale(zoomLevel)
	GTween.new(container, 0.2, { scaleX = zoomLevel, scaleY = zoomLevel }, {delay = 0, ease =easing.linear })
--	pixelAdjustment = zoomLevel * 1
	
	self:lookAt(target:getX(), target:getY())
	 

end
