
require "box2d"


scene = gideros.class(Sprite)
world = b2.World.new(0, 10, true)
worldWidth = 960
worldHeight = 640

function scene:init()

controls = controls.new(10,30)
controls:setScale(0.5)
		stage:addChild(controls)


		
	local bg = Shape.new()
	bg:beginPath()
	bg:setLineStyle(1, 0x000000,1)
	bg:setFillStyle(Shape.SOLID, 0xff0000, 0.2)
	bg:moveTo(-960/2,-640/2)
	bg:lineTo(960/2, -640/2)
	bg:lineTo(960/2, 640/2)
	bg:lineTo(-960/2, 640/2)
	bg:closePath()
	bg:endPath()

	
	--self:addChild(bg)
		

	self.world = world

	--create bounding walls outside the scene
	self:wall(0,worldHeight/2,10,worldHeight)
	self:wall(worldWidth/2,0,worldWidth,10)
	self:wall(0,150,250,10)
	self:wall(250,350,250,10)
	self:wall(worldWidth,worldHeight/2,10,worldHeight)
	self:wall(worldWidth/2,worldHeight,worldWidth,10)
	
	
	
--	self:setPosition(240, 160)
	--self:setPosition(0,-320)
--	self:setPosition(-10,0)
	--create ball
	Ball = self:ball(50,50)
	self.name = "Container"
	Ball.name = "Ball"
	
	
	Cam = Camera.new(worldWidth, worldHeight, Ball)
	
	
	--self:addChild(Cam)
	--self:setPosition(300,300)
	--Cam:setPosition(0,0)
	
	
	
	--Cam:lookAt(520,310)
	--set up debug drawing
	
	local debugDraw = b2.DebugDraw.new()
	self.world:setDebugDraw(debugDraw)
	self:addChild(debugDraw)
	
	
	
	--run world
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
	--remove event on exiting scene
	self:addEventListener("exitBegin", self.onExitBegin, self)
	--Cam:lookAt(-300,10)
	
	
end

-- for creating objects using shape
-- as example - bounding walls
function scene:wall(x, y, width, height)
	local wall = Shape.new()

	--define wall shape
	wall:beginPath()
	
	--we make use (0;0) as center of shape,
	--thus we have half of width and half of height in each direction
	wall:moveTo(-width/2,-height/2)
	wall:lineTo(width/2, -height/2)
	wall:lineTo(width/2, height/2)
	wall:lineTo(-width/2, height/2)
	wall:closePath()
	wall:endPath()
	wall:setPosition(x,y)
	
	--create box2d physical object
	local body = self.world:createBody{type = b2.STATIC_BODY}
	body:setPosition(wall:getX(), wall:getY())
	body:setAngle(wall:getRotation() * math.pi/180)
	local poly = b2.PolygonShape.new()
	poly:setAsBox(wall:getWidth()/2, wall:getHeight()/2)
	local fixture = body:createFixture{shape = poly, density = 10.0, 
	friction = 0.1, restitution = 0}
	wall.body = body
	wall.body.type = "wall"
	
	--add to scene
	self:addChild(wall)
	
	--return created object
	return wall
end

-- for creating objects using image
-- as example - ball
function scene:ball(x, y)
	--create ball bitmap object from ball graphic
	local ball = Bitmap.new(Texture.new("./crate.png"))
ball:setAnchorPoint(0.5,0.5)
	
	ball:setPosition(x,y)
	
	--get radius
	local radius = ball:getWidth()/2
	
	--create box2d physical object
	local body = self.world:createBody{type = b2.DYNAMIC_BODY}
	body:setPosition(ball:getX(), ball:getY())
	body:setAngle(ball:getRotation() * math.pi/180)
	local circle = b2.CircleShape.new(0, 0, radius)
	local fixture = body:createFixture{shape = circle, density = 1.0, 
	friction = 0.1, restitution = 0.1}
	ball.body = body
	ball.body.type = "ball"
	
	--add to scene
	self:addChild(ball)
	
	--return created object
	return ball
	
end

--running the world
function scene:onEnterFrame() 

	Cam:lookAt(Ball:getPosition())
	-- edit the step values if required. These are good defaults!
	self.world:step(1/60, 8, 3)
	--iterate through all child sprites
	for i = 1, self:getNumChildren() do
		--get specific sprite
		local sprite = self:getChildAt(i)
		-- check if sprite HAS a body (ie, physical object reference we added)
		if sprite.body then
		
			
			--update position to match box2d world object's position
			--get physical body reference
			local body = sprite.body
			--get body coordinates
			local bodyX, bodyY = body:getPosition()
			--apply coordinates to sprite
			sprite:setPosition(bodyX, bodyY)
			--apply rotation to sprite
			sprite:setRotation(body:getAngle() * 180 / math.pi)
		end
	end
end

--removing event on exiting scene
--just in case you're using SceneManager
function scene:onExitBegin()
  self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

--add created scene to stage or sceneManager
coolScene = Sprite.new()
stage:addChild(coolScene)
local mainScene = scene.new()

coolScene:addChild(mainScene)
